/**
 * @file
 * Defines behaviors for the CardPointe hosted iframe payment method form.
 */
(function ($, Drupal, drupalSettings) {

    'use strict';

    Drupal.behaviors.hostedIframe = {
      attach: function (context) {
        let token = '';
        let tokenField = document.getElementById('token');
        let expirationField = document.getElementById('expiration');

        window.addEventListener('message', function (event) {
          token = JSON.parse(event.data);
          // Set the token and expiration to the hidden form fields.
          tokenField.value = token.message;
          expirationField.value = token.expiry;
        });

        $('.button--primary').click(function (event) {
          // If the token is empty on form submit, delay the submission
          // so the token can generate first.
          if (token === '') {
            event.preventDefault();
            $('.delayed-input-submit').attr('disabled', 'disabled');
            setTimeout(function () {
              $('.commerce-checkout-flow-multistep-default').submit();
            }, 1000);
          }
        });
      }
    };
  })
(jQuery, Drupal, drupalSettings);
